
#include <math.h>
#include "util.h"

extern int no_inp, no_hid, no_tar, no_wts, nfgeval;
extern real *w, **wi, **wd, **wo, *output;
extern struct exampleset train;

real *hidden;                                    /* activity of hidden units */

extern real prior(real *dw);

real fgeval(dw)
  real *dw;
{
  int  i, j, k, l, m;
  real e = 0.0, x, y, *tmp, *pat;

  for (i=0; i<no_wts; i++) dw[i] = 0.0;                  /* zero derivatives */
  for (k=0; k<train.num; k++) {
    pat=train.inp[k];
    for (i=0; i<no_hid; i++) {                  /* compute hidden activities */
      tmp = wi[i];
      x = tmp[no_inp];                                        /* hidden bias */
      for (j=0; j<no_inp; j++) 
        x += pat[j]*tmp[j];
      hidden[i] = tanh(x);
    }
    m = 0; 
    for (i=0; i<no_tar; i++) {                  /* compute output activities */
      tmp = wo[i];
      x = tmp[no_hid]-train.tar[k][i];           /* output bias minus target */
      for (j=0; j<no_hid; j++) x += hidden[j]*tmp[j];
      tmp = wd[i];
      for (j=0; j<no_inp; j++) x += pat[j]*tmp[j];         /* direct weights */
      output[i] = x;
      e += x*x;                                  /* accumulate squared error */
      for (j=0; j<=no_hid; j++) dw[m++] += x*hidden[j];
      for (j=0; j<no_inp; j++) dw[m++] += x*pat[j];
    } 
    for (j=0; j<no_hid; j++) {
      y=hidden[j];
      x = 0.0; for (i=0; i<no_tar; i++) x += output[i]*wo[i][j];
      y=x*(1.0-y*y);
      for (l=0; l<no_inp; l++)
        dw[m++] += y*pat[l];
      dw[m++] += y;
    }  
  }
  nfgeval++;
  return 0.5*(e+prior(dw));
}
